/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

/** @module vertx-micrometer-metrics-js/prometheus_scraping_handler */
var utils = require('vertx-js/util/utils');
var RoutingContext = require('vertx-web-js/routing_context');

var io = Packages.io;
var JsonObject = io.vertx.core.json.JsonObject;
var JPrometheusScrapingHandler = Java.type('io.vertx.micrometer.PrometheusScrapingHandler');

/**

 @class
*/
var PrometheusScrapingHandler = function(j_val) {

  var j_prometheusScrapingHandler = j_val;
  var that = this;

  var __super_create = this.create;
  var __super_create = this.create;
  // A reference to the underlying Java delegate
  // NOTE! This is an internal API and must not be used in user code.
  // If you rely on this property your code is likely to break if we change it / remove it without warning.
  this._jdel = j_prometheusScrapingHandler;
};

PrometheusScrapingHandler._jclass = utils.getJavaClass("io.vertx.micrometer.PrometheusScrapingHandler");
PrometheusScrapingHandler._jtype = {accept: function(obj) {
    return PrometheusScrapingHandler._jclass.isInstance(obj._jdel);
  },wrap: function(jdel) {
    var obj = Object.create(PrometheusScrapingHandler.prototype, {});
    PrometheusScrapingHandler.apply(obj, arguments);
    return obj;
  },
  unwrap: function(obj) {
    return obj._jdel;
  }
};
PrometheusScrapingHandler._create = function(jdel) {var obj = Object.create(PrometheusScrapingHandler.prototype, {});
  PrometheusScrapingHandler.apply(obj, arguments);
  return obj;
}
/**
 Creates a Vert.x Web {@link Route} handler for Prometheus metrics scraping.
 The registry specified by <code>registryName</code> is used.

 @memberof module:vertx-micrometer-metrics-js/prometheus_scraping_handler
 @param registryName {string} the backend metrics registry 
 @return {function} a {@link Route} handler for a specific metrics registry
 */
PrometheusScrapingHandler.create =  function() {
  var __args = arguments;
  if (__args.length === 0) {
    return utils.convReturnHandler(JPrometheusScrapingHandler["create()"](), function(result) { return result._jdel; }) ;
  } else if (__args.length === 1 && typeof __args[0] === 'string') {
    return utils.convReturnHandler(JPrometheusScrapingHandler["create(java.lang.String)"](__args[0]), function(result) { return result._jdel; }) ;
  }else throw new TypeError('function invoked with invalid arguments');
};

module.exports = PrometheusScrapingHandler;